using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Diagnostics;

namespace PagerTest
{
    class Program
    {
        static void Test(string sql, int pageNo, int pageSize, General.Data.SQLDataReader dataReader, bool useRangeQuery)
        {
            System.Diagnostics.Stopwatch stopwatch = new Stopwatch();

            System.Data.DataSet ds;

            stopwatch.Reset();
            stopwatch.Start();
            if (useRangeQuery)
            {
                ds = dataReader.RangeQuery(sql, (pageNo - 1) * pageSize, pageNo * pageSize);
            }
            else
            {
                ds = dataReader.Query(sql);
            }

            stopwatch.Stop();


            Console.WriteLine(string.Format("PageNo:{0} first id = {1} last={2} Elapsed {3} ms",
                pageNo, ds.Tables[0].Rows[0][0], ds.Tables[0].Rows[9][0],
                stopwatch.ElapsedMilliseconds - dataReader.GetSchemaElapsedMilliseconds));
        }

        static void Main(string[] args)
        {
            General.Data.SQLDataReader dataReader = new General.Data.SQLDataReader();
            System.Data.SqlClient.SqlConnectionStringBuilder builder = new System.Data.SqlClient.SqlConnectionStringBuilder();
            builder.DataSource = "(local)";
            builder.InitialCatalog = "test";
            builder.IntegratedSecurity = true;



            int pageNo = 1;
            int pageSize = 100;

            int i = 0;

            dataReader.Connect(builder.ConnectionString);

            while (pageNo * pageSize <= 1000000)
            {
                Test(string.Format("exec PagedProc {0}, {1}", pageNo, pageSize), pageNo, pageSize, dataReader, false);
                Test(string.Format("exec PagedProcUseROW_NUMBER {0}, {1}", pageNo, pageSize), pageNo, pageSize, dataReader, false);
                Test(string.Format("exec spCommonPageData '*', 'r_student', NULL, NULL, 'Id',{0}, {1}", pageNo, pageSize), pageNo, pageSize, dataReader, false);
                Test(string.Format("select top {0} * from r_student order by Id", pageNo * pageSize), pageNo, pageSize, dataReader, true);


                i++;
                pageNo = (int)Math.Pow(10, i);
            }

            dataReader.Close();

            Thread.Sleep(10000);
        }
    }
}
